var socket;
var name;
var loggedIn = false;
var chatWindows = new Array();
var currentChatID = "LFG";

function addToChat(){
	var text = document.getElementById("add");
	// console.log("Sending text to server.");
	if(text.value == "" || text.value == "\n")
		return;
	socket.emit('add', { name: name, text: text.value, chatID:currentChatID});

	text.value = "";
}
window.onkeypress = function(e){
	if(e.keyCode == 13){
		addToChat();
	}
}
window.onresize = resize; 
function resize(){
	var text = document.getElementById("add");
	var textArea = document.getElementById("chatareaDiv");
	text.style.width = textArea.offsetWidth - 110;
}

function Login(){
	name = document.getElementById("name").value;
	if(name == "" || name == undefined){
		return;
	}
	if(loggedIn)
		return;
	loggedIn = true;

	if(document.URL.match("file") === null){//used to run it locally
		socket = io.connect('http://localhost');
	}
	else{
		socket = io.connect('insert your ip here.');
	}

	socket.on('connected', function(){
		socket.emit("joined", {name:name});
		document.getElementById("chatDiv").style.display = "block";
		document.getElementById("loginDiv").style.display = "none";
		document.getElementById("nameHeading").innerHTML = name;
		setTimeout(resize, 0);
	});

	socket.on('welcome', function(data){
		openChat("LFG");
		if(data.name != name){
			name = data.name;
			document.getElementById("nameHeading").innerHTML = name;
		}
		// var text = document.getElementById("chatID_LFG");
		// text.value += data.text + " " + name + "\n";
		var chatWindow = "#chatWinID_" + data.chatID; 
		data.name = "Server";
		var message = Mustache.render(chatMessageTemplate, data);
		$(chatWindow).append(message);

		for(user in data.userNames){
			if(data.userNames[user].name == "" || data.userNames[user].name == undefined){
				continue;
			}
			var li = Mustache.render(listItemTemplate, data.userNames[user]);
			$("#idList").append(li);
		}
	});

	socket.on('add', function (data){
		/*var text = document.getElementById("chatID_" + data.chatID);
		if(!text){
			console.log(data);
			return;
		}*/
		var chatWindow = "#chatWinID_" + data.chatID; 
		// text.value += data.name + ": " + data.text + "\n";
		// text.scrollTop = text.scrollHeight;
		var message;// = Mustache.render(chatMessageTemplate, data);
		if(data.name == name){
			message = Mustache.render(chatUserMessageTemplate, data);
		}
		else{
			message = Mustache.render(chatMessageTemplate, data);
		}
		$(chatWindow).append(message);
		$("#chatWindows")[0].scrollTop = $("#chatWindows")[0].scrollHeight;
		if(data.chatID != currentChatID)
			$("#tabID_" + data.chatID).addClass("newMessage");
	});

	socket.on('newUser', function(data){
		if(data.name == "" || data.name == undefined){
			return;
		}
		var li = Mustache.render(listItemTemplate, data);
		$("#idList").append(li);
	})

	socket.on('disconnectUser', function(data){
		_.each($("#idList").children(), function(child){
			if(child.id == "listID_" + data.name){
				child.parentNode.removeChild(child);
			}
		});
	})

	socket.on('createRoom', function(data){
		openChat(data.chatID);
	});
}

function ClickNew(element){
	var roomName = prompt("What would you like to name this room?", element.id + "-" + name);
	while(roomName != null && (roomName.search('_') != -1 || roomName.search(' ') != -1)){
		roomName = roomName.replace('_', '-');
		roomName = roomName.replace(' ', '-');
	}
	while(chatWindows.contains(roomName)){
		roomName = prompt("This room name already exists", element.id + "-" + name);
		while(roomName != null && (roomName.search('_') != -1 || roomName.search(' ') != -1)){
			roomName = roomName.replace('_', '-');
			roomName = roomName.replace(' ', '-');
		}
	}
	if(roomName != null)
		socket.emit('newRoom', {chatID:roomName, person:element.id});
}
function ClickAdd(element){
	var roomName = currentChatID;
	if(roomName == "LFG")
		return;
	// prompt("What would you like to name this room?", element.id + "-" + name);
	
	if(roomName != null)
		socket.emit('addToRoom', {chatID:roomName, person:element.id});
}

function openChat(chatID){
	if(chatWindows.contains(chatID)){
		return;
	}
	var newTab = Mustache.render(chatTabTemplate, {chatID:chatID});
	$("#chatTabs").append(newTab);
	var newWindow = Mustache.render(chatWindowTemplate, {chatID:chatID});
	$("#chatWindows").append(newWindow);
	chatWindows.push(chatID);

	$(function() {
		$(".tabs a").html5jTabs();
	});
	// socket.emit('joinedRoom', {chatID:chatID, person:name});
}

function doubleClickTab(element){
	if(element.innerHTML == "LFG"){
		return;
	}
	var message = "Sure you want to close: " + element.innerHTML + "?";
	if(confirm(message)){
		closeChat(element.innerHTML);
	}
}

function closeChat(chatID){
	if(chatID == "LFG"){
		return;
	}
	var windowID = "#chatWinID_" + chatID;
	var tabID = "#tabID_" + chatID;
	$(windowID)[0].parentNode.removeChild($(windowID)[0]);
	$(tabID)[0].parentNode.removeChild($(tabID)[0]);

	currentChatID = "LFG";
	$("#chatWinID_LFG").show().addClass("active");
	$("#tabID_LFG").addClass("active");

	socket.emit('leftRoom', {chatID:chatID, person:name});
	chatWindows.remove(chatID);
}


;(function($){
	$.fn.html5jTabs = function(options){
		return this.each(function(index, value){
			var obj = $(this),
			objFirst = obj.eq(index),
			objNotFirst = obj.not(objFirst);

			$("#" +  objNotFirst.attr("data-toggle")).hide();
			$(this).eq(index).addClass("active");

			obj.click(function(evt){

			toggler = "#" + obj.attr("data-toggle");

			currentChatID = obj.attr("data-toggle").split("_")[1]

			togglerRest = $(toggler).parent().find("div");

			togglerRest.hide().removeClass("active");
			$(toggler).show().addClass("active");

			//toggle Active Class on tab buttons
			$(this).parent("div").find("a").removeClass("active");
			$(this).addClass("active");
			$(this).removeClass("newMessage");
			$("#chatWindows")[0].scrollTop = $("#chatWindows")[0].scrollHeight;

			return false; //Stop event Bubbling and PreventDefault
			});
		});
	};
}(jQuery));

Array.prototype.contains = function(value){
	for(var i = 0; i < this.length; i++){
		if(this[i] == value){
			return true;
		}
	}
	return false;
}

Array.prototype.remove = function(value){
	if(this.contains(value)){
		var index = this.indexOf(value);
		this[index] = this[this.length-1];
		this.pop();
	}
}