var io = require('socket.io').listen(80);
var sockets = new Array();
var rooms = new Array();

io.sockets.on('connection', function (socket) {
	sockets.push(socket);
	socket.emit('connected');

	socket.on('joined', function(data){
		var name = data.name;
		for (var i = sockets.length - 1; i >= 0; i--) {
			if(sockets[i].name == name){
				name += Math.round(Math.random()*9);
				i = sockets.length;
			}
		};
		var userNames = new Array();
		for (var i = sockets.length - 1; i >= 0; i--) {
			userNames.push({name:sockets[i].name});
		};
		socket.name = name;
		socket.emit('welcome', { text: 'Welcome' , name:name, userNames:userNames, chatID:"LFG"});
		socket.broadcast.emit('newUser', {name:name});
	});

	socket.on('add', function (data) {
		if(data.chatID == "LFG"){
			for(var i = sockets.length - 1; i >= 0; i--)
				sockets[i].emit('add', data);
		}
		else{
			for(var i = rooms.length - 1; i >= 0; i--){
				if(rooms[i].name == data.chatID){
					for(var j = rooms[i].members.length - 1; j >= 0; j--){
						rooms[i].members[j].emit('add', data);
					}
				}
			};
		}
	});

	socket.on('newRoom', function(data){
		var chatID = data.chatID;
		while(rooms.contains(data.chatID)){
			chatID += Math.round(Math.random()*9);
		}
		socket.emit('createRoom', {chatID:chatID})
		var i;
		for(i = sockets.length - 1; i >= 0; i--){
			if(sockets[i].name == data.person){
				sockets[i].emit('createRoom', {chatID:chatID});
				break;
			}
		};
		rooms.push({name: chatID, members:[socket, sockets[i]]})
		var data2 = {};
		data2.text = data.person + " has joined the room.";
		data2.name = "Server";
		data2.chatID = chatID;
		socket.emit('add', data2);
		sockets[i].emit('add', data2);

		data2.text = socket.name + " has joined the room.";
		data2.name = "Server";
		data2.chatID = chatID;
		socket.emit('add', data2);
		sockets[i].emit('add', data2);
	});

	socket.on('addToRoom', function(data){
		var sockett;
		for (var i = sockets.length - 1; i >= 0; i--) {
			if(sockets[i].name == data.person){
				sockets[i].emit('createRoom', {chatID:data.chatID});
				sockett = sockets[i];
				break;
			}
		};
		for(var i = rooms.length - 1; i >= 0; i--){
			if(rooms[i].name == data.chatID){
				for(var j = rooms[i].members.length - 1; j >= 0; j--){
					data.text = data.person + " has joined the room.";
					data.name = "Server";
					rooms[i].members[j].emit('add', data);

					sockett.emit('add', {chatID:data.chatID, name:"server", text: rooms[i].members[j].name + " is in the room."})
					for(var k = sockets.length - 1; k >= 0; k--){
						if(sockets[k].name == data.person){
							if(!rooms[i].members.contains(sockets[k])){
								rooms[i].members.push(sockets[k]);
							}
							break;
						}
					};
				}
				break;
			}
		};
	});

	/*socket.on('joinedRoom', function(data){
		for(var i = rooms.length - 1; i >= 0; i--){
			if(rooms[i].name == data.chatID){
				for(var j = rooms[i].members.length - 1; j >= 0; j--){
					data.text = data.person + " has joined the room.";
					data.name = "Server";
					rooms[i].members[j].emit('add', data);
					for(var k = sockets.length - 1; k >= 0; k--){
						if(sockets[k].name == data.person){
							rooms[i].members.push(sockets[k]);
							break;
						}
					};
					break;
				}
			}
		};
	});*/

	socket.on('leftRoom', function(data){
		for(var i = rooms.length - 1; i >= 0; i--){
			if(rooms[i].name == data.chatID){
				for(var k = sockets.length - 1; k >= 0; k--){
					if(sockets[k].name == data.person){
						rooms[i].members.remove(sockets[k]);
						break;
					}
				};
				if(rooms[i].members.length <= 0){
					rooms.remove(rooms[i].name);
					break;
				}
				for(var j = rooms[i].members.length - 1; j >= 0; j--){
					data.chatID = rooms[i].name;
					data.text = data.person + " has left the room.";
					data.name = "Server";
					rooms[i].members[j].emit('add', data);
				}
				continue;
			}
		};
	});

	socket.on('disconnect', function (){
		socket.broadcast.emit('disconnectUser', {name:socket.name});
		console.log("disconnect: " + socket.name);

		for (var i = rooms.length - 1; i >= 0; i--) {
			if(rooms[i].members.contains(socket)){
				rooms[i].members.remove(socket);
				if(rooms[i].members.length <= 0){
					rooms.remove(rooms[i].name);
					continue;
				}
				var data = {};
				data.chatID = rooms[i].name;
				data.text = socket.name + " has left the room.";
				data.name = "Server";
				for(var j = rooms[i].members.length - 1; j >= 0; j--){
					rooms[i].members[j].emit('add', data);
				}
			}
		};

		for(var i = 0; i < sockets.length; i++){
			if(sockets[i] == socket){
				sockets[i] = sockets[sockets.length-1];
				sockets.pop();
				break;
			}
		}
	});
});


io.configure(function(){
  // io.set('transports', ['websocket']);
  io.set('log level', 1);
});

Array.prototype.contains = function(value){
	for(var i = 0; i < this.length; i++){
		if(this[i] == value){
			return true;
		}
	}
	return false;
}

Array.prototype.remove = function(value){
	if(this.contains(value)){
		var index = this.indexOf(value);
		this[index] = this[this.length-1];
		this.pop();
	}
}